local frac = FRACUNIT

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p and p.mo and p.mo.valid) return end
		
		if skins[p.advmenu.curBot].name == "sonic"
			if p.dashmode < 3*TICRATE
				p.normalspeed = skins[p.mo.skin].normalspeed + 5*frac
			end
		else
			if p.dashmode < 3*TICRATE
				p.normalspeed = skins[p.mo.skin].normalspeed
			end
		end
		
		if skins[p.advmenu.curBot].name == "tails"
			p.jumpfactor = skins[p.mo.skin].jumpfactor + frac/6
		else
			p.jumpfactor = skins[p.mo.skin].jumpfactor
		end
		
		if skins[p.advmenu.curBot].name == "knuckles"
			if not (skins[p.mo.skin].flags & SF_CANBUSTWALLS)
				p.charflags = $1|SF_CANBUSTWALLS
			end
		else
			if not (skins[p.mo.skin].flags & SF_CANBUSTWALLS)
				p.charflags = $ & ~SF_CANBUSTWALLS
			end
		end
		
		if skins[p.advmenu.curBot].name == "amy"
			if not (skins[p.mo.skin].flags & SF_MULTIABILITY)
				p.charflags = $1|SF_MULTIABILITY
			end
		else
			if not (skins[p.mo.skin].flags & SF_MULTIABILITY)
				p.charflags = $ & ~SF_MULTIABILITY
			end
		end
		
		if skins[p.advmenu.curBot].name == "fang"
			p.actionspd = skins[p.mo.skin].actionspd + 10*frac
			if skins[p.mo.skin].ability == CA_THOK
				p.charability = CA_HOMINGTHOK
			end
			
			if skins[p.mo.skin].ability == CA_NONE
				p.charability = CA_DOUBLEJUMP
			end
		else
			if skins[p.mo.skin].ability == CA_THOK
				p.charability = CA_THOK
			end
			
			if skins[p.mo.skin].ability == CA_NONE
				p.charability = CA_NONE
			end
		end
		
		if skins[p.advmenu.curBot].name == "metalsonic"
			if not (skins[p.mo.skin].flags & SF_DASHMODE)
				p.charflags = $1|SF_DASHMODE
			end
		else
			if not (skins[p.mo.skin].flags & SF_DASHMODE)
				p.charflags = $ & ~SF_DASHMODE
			end
		end
	end
end)

addHook("BotTiccmd", function(b)
	if not (b and b.mo and b.mo.valid) return end
	
	if b.botleader
		b.botleader.botnum = #b
	end
end)

